//сырой скетч с меню вольтметром и осцилом и частотометром 2 версия
#define USE_SSD1306 // Use I2C OLED screen on SSD1306 chipset
#include "U8g2lib.h"
const uint8_t bufferSize = 128;
const uint8_t pinAnalogIn = A7;
uint8_t buffer[bufferSize];
U8G2_SH1106_128X32_VISIONOX_F_HW_I2C u8g2(U8G2_R0, /* reset=*/ U8X8_PIN_NONE);
float val = 0;
unsigned long timer;
unsigned long timer2;
unsigned long timer3;
unsigned long timer4;
unsigned long timer5;
unsigned long timer6;
unsigned long timer7;
unsigned long timer8;
int n = 9;
int q = 0;
int w = 3;
int g = 20;
int u = 0;
int e = 0;
int r = 0;
int k = 10000;
int t = 0;
int m = 5;
int z = 100;
int Htime = 0;            // переменная целого типа для хранения длительности высокого уровня
int Ltime = 0;              // переменная целого типа для хранения длительности низкого уровня
float Ttime;            // переменная для хранения длительности периода
float rtime;            // переменная для хранения длительности периода
int freq;        // переменная для хранения значения частоты
int pwm;        // переменная для хранения значения частоты
float proc;        // переменная для хранения значения частоты
void setup() {
  //  Serial.begin(9600);
  pinMode(12, INPUT_PULLUP);
  pinMode(10, INPUT_PULLUP);
  pinMode(A7, INPUT);
  pinMode(4, INPUT); // контакт 8 конфигурируем на ввод данных частотомер
  pinMode(LED_BUILTIN, OUTPUT);
  // Инициализируем дисплей
  u8g2.begin();
  // Очищаем память
  u8g2.clearBuffer();
  // Выбираем шрифт
  u8g2.setFont(u8g2_font_10x20_te); //   u8g2_font_luBIS08_tr  u8g2_font_ncenR08_tr  u8g2_font_4x6_tr
  // Указываем положение курсора
  u8g2.setCursor(0, 13);
  // Выводим строку
  u8g2.print("<  VIBOR  >");
  u8g2.setCursor(0, 32);
  u8g2.print(". . . . . .");
  // Отсылаем данные на дисплей
  u8g2.sendBuffer();
}
void loop() {
  tone(LED_BUILTIN, 100, 50000); // выводим тестовый сгнал частоты на 13 пин 100 герц , шим 50%, длительность 50секунд
  if (digitalRead(12) == 0) {
    q++;
    u = 0;
    r = 0;
    e = 0;
    delay(500);
  }
  if (digitalRead(10) == 0) {
    m = m + 10;
    if (m > 35)m = 5;
    if (m == 5) z = 100;
    if (m == 15) z = 300;
    if (m == 25) z = 500;
    if (m == 35) z = 700;
    delay(500);
  }
  if (u == 0 && q == 1 ) {
    u8g2.clearBuffer();
    u8g2.setCursor(0, 13);
    u8g2.print("VOLTMETR");
    u8g2.setCursor(0, 32);
    u8g2.print("| . . . . .");
    u8g2.sendBuffer();
    timer = millis();
    u = 1;
    r = 0;
  }
  if (u == 0 && q == 2 ) {
    u8g2.clearBuffer();
    u8g2.setCursor(0, 13);
    u8g2.print("OSCILOGRAF");
    u8g2.setCursor(0, 32);
    u8g2.print(". | . . . .");
    u8g2.sendBuffer();
    timer7 = millis();
    u = 1;
    r = 0;
  }
  if ( u == 0 && q == 3  ) {
    u8g2.clearBuffer();
    u8g2.setCursor(0, 13);
    u8g2.print("SHASTOTOMER");
    u8g2.setCursor(0, 32);
    u8g2.print(". . | . . .");
    u8g2.sendBuffer();

    timer3 = millis();
    u = 1;
    r = 0;
  }
  if ( u == 0 && q == 4  ) {
    u8g2.clearBuffer();
    u8g2.setCursor(0, 13);
    u8g2.print("GENERATOR");

    u8g2.setCursor(0, 32);
    u8g2.print(". . . | . .");
    u8g2.sendBuffer();
    timer4 = millis();
    u = 1;
  }
  if ( u == 0 && q == 5  ) {
    u8g2.clearBuffer();
    u8g2.setCursor(0, 13);
    u8g2.print("FORSYNKI");

    u8g2.setCursor(0, 32);
    u8g2.print(". . . . | .");
    u8g2.sendBuffer();
    timer5 = millis();
    u = 1;
  }
  if ( u == 0 && q == 6  ) {
    u8g2.clearBuffer();
    u8g2.setCursor(0, 13);
    u8g2.print("DPKV 60 - 2");
    u8g2.setCursor(0, 32);
    u8g2.print(". . . . . |");
    u8g2.sendBuffer();
    timer6 = millis();
    u = 1;
  }
  if (q >= 7) {
    q = 1;
  }
  ///////////////////////////////////////////////////////////////////////////
  if (r == 1 && e == 2)  {  // короткий путь до вольтметра
    if (millis() - timer7 > 500 ) {
      timer7 = millis();
      voltmetr();
    }
  }
  if (millis() - timer > 3000 && q == 1 && r == 0)  { // если выбран вольтметр
    u8g2.clearBuffer();
    u8g2.sendBuffer();
    timer = millis();
    voltmetr();
  }
  if (u == 0 && q == 0 && millis() - timer8 > 3000) { // само заходит в вольтметр если ничего не нажато
    u8g2.clearBuffer();
    u8g2.sendBuffer();
    u = 1;
    q = 1;
    voltmetr();
  }
  ////////////////
  if (millis() - timer7 > 3000 && q == 2 && r == 0)  { // если выбран осцилограф
    u8g2.clearBuffer();
    u8g2.sendBuffer();
    timer7 = millis();
    oscilograf();
  }
  if (r == 1 && e == 3)  {  // короткий путь до осцилограф
    oscilograf();
  }
  ////////////////
  if (millis() - timer3 > 3000 && q == 3 && r == 0)  { // если выбран частотомер
    u8g2.clearBuffer();
    u8g2.sendBuffer();
    timer3 = millis();
    shastotomer();
  }
  if (r == 1 && e == 4)  {  // короткий путь до осцилограф
    shastotomer();
  }
}
////////////////////////////////////////////////////////////////////////////////////////
void shastotomer() {  // функция частотомер
  Ttime = Htime + Ltime;
  rtime = Ttime - Ltime;
  proc =  Ttime / 100;
  pwm = rtime / proc;
  freq = 1000000 / Ttime; // вычисляем значение частоты учитывая что время у нас в микросекундах
  u8g2.firstPage();
  u8g2.setCursor(0, 13);
  u8g2.print("PWM  Hz     ");
  u8g2.setCursor(0, 32);
  u8g2.print(pwm);
  u8g2.print("   ");
  u8g2.print(freq);
  u8g2.sendBuffer();
  if (millis() - timer5 > 1000) {
    Htime = pulseIn(4, HIGH);   // считываем длительность высокого уровня
    Ltime = pulseIn(4, LOW);     // считываем длительность низкого уровня
    timer5 = millis();
  }
  r = 1;
  e = 4;
}
void voltmetr() {  // функция вольтметр
  val = analogRead(A7);
  val = (50 / 1023.0) * val;
  u8g2.firstPage();
  u8g2.setCursor(0, 13);
  u8g2.print("VOLTMETR");
  u8g2.setCursor(0, 32);
  u8g2.print(val);
  u8g2.print(" volt     ");
  u8g2.sendBuffer();
  r = 1;
  e = 2;
}
void oscilograf() {  // функция осцилограф
  uint32_t start = micros();
  for (uint8_t x = 0; x < bufferSize; ++x) {
    buffer[x] = map(analogRead(pinAnalogIn), 0, z, u8g2.getDisplayHeight() - 1, 0);
  }
  u8g2.firstPage();
  do {
    drawScreen(start);
  } while (u8g2.nextPage());
  r = 1;
  e = 3;
}
void drawScreen(uint32_t duration) {  // функция для работы осцилографа
  for (int8_t v = 5; v >= 0; --v) {
    uint8_t tickY = u8g2.getDisplayHeight() - u8g2.getDisplayHeight() * v / 5;
    for (uint8_t x = 0; x < u8g2.getDisplayWidth(); x += 8)
      u8g2.drawPixel(x, tickY);
  }
  for (uint8_t x = 1; x < bufferSize; ++x) {
    u8g2.drawLine(x - 1, buffer[x - 1], x, buffer[x]);
  }
  u8g2.setCursor(0, 13);
  u8g2.print(m);
}
